diff --git a/libavcodec/libx264.c b/libavcodec/libx264.c
index 9836818..c5e0231 100644
--- a/libavcodec/libx264.c
+++ b/libavcodec/libx264.c
@@ -466,29 +466,29 @@ static int X264_frame(AVCodecContext *ctx, AVPacket *pkt, const AVFrame *frame,
         }
 
         if (x4->udu_sei) {
-        for (int j = 0; j < frame->nb_side_data; j++) {
-            AVFrameSideData *side_data = frame->side_data[j];
-            void *tmp;
-            x264_sei_payload_t *sei_payload;
-            if (side_data->type != AV_FRAME_DATA_SEI_UNREGISTERED)
-                continue;
-            tmp = av_fast_realloc(sei->payloads, &sei_data_size, (sei->num_payloads + 1) * sizeof(*sei_payload));
-            if (!tmp) {
-                free_picture(ctx);
-                return AVERROR(ENOMEM);
-            }
-            sei->payloads = tmp;
-            sei->sei_free = av_free;
-            sei_payload = &sei->payloads[sei->num_payloads];
-            sei_payload->payload = av_memdup(side_data->data, side_data->size);
-            if (!sei_payload->payload) {
-                free_picture(ctx);
-                return AVERROR(ENOMEM);
+            for (int j = 0; j < frame->nb_side_data; j++) {
+                AVFrameSideData *side_data = frame->side_data[j];
+                void *tmp;
+                x264_sei_payload_t *sei_payload;
+                if (side_data->type != AV_FRAME_DATA_SEI_UNREGISTERED)
+                    continue;
+                tmp = av_fast_realloc(sei->payloads, &sei_data_size, (sei->num_payloads + 1) * sizeof(*sei_payload));
+                if (!tmp) {
+                    free_picture(ctx);
+                    return AVERROR(ENOMEM);
+                }
+                sei->payloads = tmp;
+                sei->sei_free = av_free;
+                sei_payload = &sei->payloads[sei->num_payloads];
+                sei_payload->payload = av_memdup(side_data->data, side_data->size);
+                if (!sei_payload->payload) {
+                    free_picture(ctx);
+                    return AVERROR(ENOMEM);
+                }
+                sei_payload->payload_size = side_data->size;
+                sei_payload->payload_type = SEI_TYPE_USER_DATA_UNREGISTERED;
+                sei->num_payloads++;
             }
-            sei_payload->payload_size = side_data->size;
-            sei_payload->payload_type = SEI_TYPE_USER_DATA_UNREGISTERED;
-            sei->num_payloads++;
-        }
         }
     }
 
diff --git a/libavcodec/libx265.c b/libavcodec/libx265.c
index 47d0103..851f099 100644
--- a/libavcodec/libx265.c
+++ b/libavcodec/libx265.c
@@ -545,31 +545,31 @@ static int libx265_encode_frame(AVCodecContext *avctx, AVPacket *pkt,
         }
 
         if (ctx->udu_sei) {
-        for (i = 0; i < pic->nb_side_data; i++) {
-            AVFrameSideData *side_data = pic->side_data[i];
-            void *tmp;
-            x265_sei_payload *sei_payload;
-
-            if (side_data->type != AV_FRAME_DATA_SEI_UNREGISTERED)
-                continue;
-
-            tmp = av_fast_realloc(ctx->sei_data,
-                                  &ctx->sei_data_size,
-                                  (sei->numPayloads + 1) * sizeof(*sei_payload));
-            if (!tmp) {
-                av_freep(&x265pic.userData);
-                av_freep(&x265pic.quantOffsets);
-                return AVERROR(ENOMEM);
+            for (i = 0; i < pic->nb_side_data; i++) {
+                AVFrameSideData *side_data = pic->side_data[i];
+                void *tmp;
+                x265_sei_payload *sei_payload;
+
+                if (side_data->type != AV_FRAME_DATA_SEI_UNREGISTERED)
+                    continue;
+
+                tmp = av_fast_realloc(ctx->sei_data,
+                        &ctx->sei_data_size,
+                        (sei->numPayloads + 1) * sizeof(*sei_payload));
+                if (!tmp) {
+                    av_freep(&x265pic.userData);
+                    av_freep(&x265pic.quantOffsets);
+                    return AVERROR(ENOMEM);
+                }
+                ctx->sei_data = tmp;
+                sei->payloads = ctx->sei_data;
+                sei_payload = &sei->payloads[sei->numPayloads];
+                sei_payload->payload = side_data->data;
+                sei_payload->payloadSize = side_data->size;
+                /* Equal to libx265 USER_DATA_UNREGISTERED */
+                sei_payload->payloadType = SEI_TYPE_USER_DATA_UNREGISTERED;
+                sei->numPayloads++;
             }
-            ctx->sei_data = tmp;
-            sei->payloads = ctx->sei_data;
-            sei_payload = &sei->payloads[sei->numPayloads];
-            sei_payload->payload = side_data->data;
-            sei_payload->payloadSize = side_data->size;
-            /* Equal to libx265 USER_DATA_UNREGISTERED */
-            sei_payload->payloadType = SEI_TYPE_USER_DATA_UNREGISTERED;
-            sei->numPayloads++;
-        }
         }
     }
 